import java.util.Scanner;

class Tabuleiro{
	
	private int[][] matriz;
	
	public Tabuleiro(){
		this.matriz = new int[4][5];
	}
	
	public void novaPosicao(int x, int y){
		this.matriz[x][y]++;
	}
	
	public void imprimirMaisVisitada(){
		int maior = 0;
		for(int i = 0; i < this.matriz.length; i++){
			for(int j = 0; j < this.matriz[i].length; j++){
				if(this.matriz[i][j] > maior)
					maior = this.matriz[i][j];
			}
		}
		System.out.println("O nmero mximo de visitas : " + maior);
	}
}

class PecaDoJogo{
	
	private int x;
	private int y;
	private Tabuleiro tabuleiro;
	
	public PecaDoJogo(int x, int y, Tabuleiro tab){
		this.tabuleiro = tab;
		this.novaPosicao(x, y);
	}
	
	public void novaPosicao(int x, int y){
		this.x = x;
		this.y = y;
		this.tabuleiro.novaPosicao(x, y);
	}
}

public class Jogador{
	
	private Tabuleiro tabuleiro;
	private PecaDoJogo[] pecas;
	private boolean primeiraRodada;
	private Scanner input;
	
	public Jogador(){
		this.input = new Scanner(System.in);
		this.tabuleiro = new Tabuleiro();
		this.pecas = new PecaDoJogo[4];
		this.primeiraRodada = true;
	}
	
	public void novaRodada(){
		int x, y;
				
		for(int i = 0; i < 4; i++){
			System.out.println("Digite as posies X e Y da pea " + (i+1) + ": ");
			x = this.input.nextInt();
			y = this.input.nextInt();
			
			if(this.primeiraRodada)
				this.pecas[i] = new PecaDoJogo(x, y, this.tabuleiro);
			else
				this.pecas[i].novaPosicao(x, y);
		}
		
		if(this.primeiraRodada)
			this.primeiraRodada = false;
	}
	
	public boolean desejaContinuar(){
		boolean escolha = false;
		String opcao = "";
		
		System.out.println("Voc deseja continuar a jogar? (S/n)");
		opcao = this.input.next();
		
		if(opcao.equals("S")){
			escolha = true;
		}
		else{
			escolha = false;
			this.tabuleiro.imprimirMaisVisitada();
		}
		
		return escolha;
	}
	
	public static void main(String[] args){
		Jogador jogador = new Jogador();
		
		do{		
			jogador.novaRodada();
			
		} while(jogador.desejaContinuar());
	}
}
